diff a/src/hotspot/share/include/jvm.h b/src/hotspot/share/include/jvm.h
--- a/src/hotspot/share/include/jvm.h
+++ b/src/hotspot/share/include/jvm.h
@@ -85,10 +85,16 @@
 JVM_InternString(JNIEnv *env, jstring str);
 
 /*
  * java.lang.System
  */
+JNIEXPORT jboolean JNICALL
+JVM_AOTIsTraining(JNIEnv *env);
+
+JNIEXPORT void JNICALL
+JVM_AOTEndTraining(JNIEnv *env);
+
 JNIEXPORT jlong JNICALL
 JVM_CurrentTimeMillis(JNIEnv *env, jclass ignored);
 
 JNIEXPORT jlong JNICALL
 JVM_NanoTime(JNIEnv *env, jclass ignored);
@@ -210,10 +216,13 @@
 JVM_GetRandomSeedForDumping();
 
 JNIEXPORT void JNICALL
 JVM_LogLambdaFormInvoker(JNIEnv* env, jstring line);
 
+JNIEXPORT void JNICALL
+JVM_LogDynamicProxy(JNIEnv *env, jobject loader, jstring proxy_name, jobjectArray interfaces, jint accessFlags);
+
 JNIEXPORT void JNICALL
 JVM_DumpClassListToFile(JNIEnv* env, jstring fileName);
 
 JNIEXPORT void JNICALL
 JVM_DumpDynamicArchive(JNIEnv* env, jstring archiveName);
diff a/src/hotspot/share/interpreter/abstractInterpreter.cpp b/src/hotspot/share/interpreter/abstractInterpreter.cpp
--- a/src/hotspot/share/interpreter/abstractInterpreter.cpp
+++ b/src/hotspot/share/interpreter/abstractInterpreter.cpp
@@ -169,21 +169,24 @@
     if (m->is_continuation_native_intrinsic()) {
       // This entry will never be called.  The real entry gets generated later, like for MH intrinsics.
       return abstract;
     }
     assert(!m->is_method_handle_intrinsic(), "overlapping bits here, watch out");
-    return m->is_synchronized() ? native_synchronized : native;
+    if (m->is_synchronized()) {
+      return m->has_upcall_on_method_entry() ? native_synchronized_upcalls : native_synchronized;
+    }
+    return m->has_upcall_on_method_entry() ? native_upcalls : native;
   }
 
   // Synchronized?
   if (m->is_synchronized()) {
-    return zerolocals_synchronized;
+    return m->has_upcall_on_method_entry() ? zerolocals_synchronized_upcalls : zerolocals_synchronized;
   }
 
   // Empty method?
   if (m->is_empty_method()) {
-    return empty;
+    return m->has_upcall_on_method_entry() ? empty_upcalls : empty;
   }
 
   // Getter method?
   if (m->is_getter()) {
     return getter;
@@ -193,11 +196,11 @@
   if (m->is_setter()) {
     return setter;
   }
 
   // Note: for now: zero locals for all non-empty methods
-  return zerolocals;
+  return m->has_upcall_on_method_entry() ? zerolocals_upcalls : zerolocals;
 }
 
 vmIntrinsics::ID AbstractInterpreter::method_intrinsic(MethodKind kind) {
   switch (kind) {
   case java_lang_math_sin         : return vmIntrinsics::_dsin;
diff a/src/hotspot/share/interpreter/abstractInterpreter.hpp b/src/hotspot/share/interpreter/abstractInterpreter.hpp
--- a/src/hotspot/share/interpreter/abstractInterpreter.hpp
+++ b/src/hotspot/share/interpreter/abstractInterpreter.hpp
@@ -57,13 +57,18 @@
   friend class TemplateInterpreterGenerator;
  public:
   enum MethodKind {
     zerolocals,                                                 // method needs locals initialization
     zerolocals_synchronized,                                    // method needs locals initialization & is synchronized
+    zerolocals_upcalls,                                         // method needs locals initialization & has runtime upcalls
+    zerolocals_synchronized_upcalls,                            // method needs locals initialization & is synchronized & has runtime upcalls
     native,                                                     // native method
     native_synchronized,                                        // native method & is synchronized
+    native_upcalls,                                             // native method & has runtime upcalls
+    native_synchronized_upcalls,                                // native method & is synchronized & has runtime upcalls
     empty,                                                      // empty method (code: _return)
+    empty_upcalls,                                              // empty method & has runtime upcalls (code: _return)
     getter,                                                     // getter method
     setter,                                                     // setter method
     abstract,                                                   // abstract method (throws an AbstractMethodException)
     method_handle_invoke_FIRST,                                 // java.lang.invoke.MethodHandles::invokeExact, etc.
     method_handle_invoke_LAST                                   = (method_handle_invoke_FIRST
diff a/src/hotspot/share/interpreter/bytecodeHistogram.cpp b/src/hotspot/share/interpreter/bytecodeHistogram.cpp
--- a/src/hotspot/share/interpreter/bytecodeHistogram.cpp
+++ b/src/hotspot/share/interpreter/bytecodeHistogram.cpp
@@ -27,61 +27,50 @@
 #include "memory/resourceArea.hpp"
 #include "runtime/os.hpp"
 #include "utilities/growableArray.hpp"
 
 // ------------------------------------------------------------------------------------------------
-// Non-product code
-#ifndef PRODUCT
 
 // Implementation of BytecodeCounter
 
-int   BytecodeCounter::_counter_value = 0;
+jlong BytecodeCounter::_counter_value = 0;
 jlong BytecodeCounter::_reset_time    = 0;
 
-
 void BytecodeCounter::reset() {
   _counter_value = 0;
   _reset_time    = os::elapsed_counter();
 }
 
-
 double BytecodeCounter::elapsed_time() {
   return (double)(os::elapsed_counter() - _reset_time) / (double)os::elapsed_frequency();
 }
 
-
 double BytecodeCounter::frequency() {
   return (double)counter_value() / elapsed_time();
 }
 
-
 void BytecodeCounter::print() {
-  tty->print_cr(
-    "%d bytecodes executed in %.1fs (%.3fMHz)",
-    counter_value(),
-    elapsed_time(),
-    frequency() / 1000000.0
-  );
+  tty->print_cr(JLONG_FORMAT " bytecodes executed in %.1fs (%.3fMHz)",
+                counter_value(), elapsed_time(), frequency() / 1000000.0);
 }
 
 
 // Helper class for sorting
 
 class HistoEntry: public ResourceObj {
- private:
+private:
   int             _index;
   int             _count;
 
- public:
+public:
   HistoEntry(int index, int count)                         { _index = index; _count = count; }
   int             index() const                            { return _index; }
   int             count() const                            { return _count; }
 
   static int      compare(HistoEntry** x, HistoEntry** y)  { return (*x)->count() - (*y)->count(); }
 };
 
-
 // Helper functions
 
 static GrowableArray<HistoEntry*>* sorted_array(int* array, int length) {
   GrowableArray<HistoEntry*>* a = new GrowableArray<HistoEntry*>(length);
   int i = length;
@@ -140,10 +129,12 @@
   float rel_sum = (float)abs_sum * 100.0F / (float)tot;
   tty->print_cr("%10d  %7.2f%%    (cutoff = %.2f%%)", abs_sum, rel_sum, cutoff);
   tty->cr();
 }
 
+// Non-product code
+#ifndef PRODUCT
 
 // Implementation of BytecodePairHistogram
 
 int BytecodePairHistogram::_index;
 int BytecodePairHistogram::_counters[BytecodePairHistogram::number_of_pairs];
diff a/src/hotspot/share/interpreter/bytecodeHistogram.hpp b/src/hotspot/share/interpreter/bytecodeHistogram.hpp
--- a/src/hotspot/share/interpreter/bytecodeHistogram.hpp
+++ b/src/hotspot/share/interpreter/bytecodeHistogram.hpp
@@ -30,45 +30,45 @@
 
 // BytecodeCounter counts the number of bytecodes executed
 
 class BytecodeCounter: AllStatic {
  private:
-  NOT_PRODUCT(static int   _counter_value;)
-  NOT_PRODUCT(static jlong _reset_time;)
+  static jlong _counter_value;
+  static jlong _reset_time;
 
   friend class TemplateInterpreterGenerator;
   friend class         BytecodeInterpreter;
 
  public:
   // Initialization
-  static void reset()                      PRODUCT_RETURN;
+  static void reset();
 
   // Counter info (all info since last reset)
-  static int    counter_value()            PRODUCT_RETURN0 NOT_PRODUCT({ return _counter_value; });
-  static double elapsed_time()             PRODUCT_RETURN0; // in seconds
-  static double frequency()                PRODUCT_RETURN0; // bytecodes/seconds
+  static jlong  counter_value() { return _counter_value; }
+  static double elapsed_time(); // in seconds
+  static double frequency();    // bytecodes/seconds
 
   // Counter printing
-  static void   print()                    PRODUCT_RETURN;
+  static void   print();
 };
 
 
 // BytecodeHistogram collects number of executions of bytecodes
 
 class BytecodeHistogram: AllStatic {
  private:
-  NOT_PRODUCT(static int _counters[Bytecodes::number_of_codes];)   // a counter for each bytecode
+  static int _counters[Bytecodes::number_of_codes];   // a counter for each bytecode
 
   friend class TemplateInterpreterGenerator;
   friend class         BytecodeInterpreter;
 
  public:
   // Initialization
-  static void reset()                       PRODUCT_RETURN; // reset counters
+  static void reset(); // reset counters
 
   // Profile printing
-  static void print(float cutoff = 0.01F)   PRODUCT_RETURN; // cutoff in percent
+  static void print(float cutoff); // cutoff in percent
 };
 
 
 // BytecodePairHistogram collects number of executions of bytecode pairs.
 // A bytecode pair is any sequence of two consecutive bytecodes.
diff a/src/hotspot/share/interpreter/bytecodeTracer.cpp b/src/hotspot/share/interpreter/bytecodeTracer.cpp
--- a/src/hotspot/share/interpreter/bytecodeTracer.cpp
+++ b/src/hotspot/share/interpreter/bytecodeTracer.cpp
@@ -21,10 +21,11 @@
  * questions.
  *
  */
 
 #include "precompiled.hpp"
+#include "cds/heapShared.hpp"
 #include "classfile/classPrinter.hpp"
 #include "classfile/javaClasses.inline.hpp"
 #include "interpreter/bytecodeHistogram.hpp"
 #include "interpreter/bytecodeStream.hpp"
 #include "interpreter/bytecodeTracer.hpp"
@@ -128,14 +129,14 @@
         code == Bytecodes::_return_register_finalizer ||
         (code >= Bytecodes::_ireturn && code <= Bytecodes::_return)) {
       int bci = (int)(bcp - method->code_base());
       st->print("[" UINTX_FORMAT  "] ", Thread::current()->osthread()->thread_id_for_printing());
       if (Verbose) {
-        st->print("%8d  %4d  " INTPTR_FORMAT " " INTPTR_FORMAT " %s",
+        st->print(JLONG_FORMAT_W(8) "  %4d  " INTPTR_FORMAT " " INTPTR_FORMAT " %s",
             BytecodeCounter::counter_value(), bci, tos, tos2, Bytecodes::name(code));
       } else {
-        st->print("%8d  %4d  %s",
+        st->print(JLONG_FORMAT_W(8) "  %4d  %s",
             BytecodeCounter::counter_value(), bci, Bytecodes::name(code));
       }
       print_attributes(bci, st);
     }
     // Set is_wide for the next one, since the caller of this doesn't skip
@@ -173,11 +174,13 @@
     } else {
       st->print("%4d %s", bci, Bytecodes::name(code));
     }
     _next_pc = is_wide() ? bcp+2 : bcp+1;
     print_attributes(bci, st);
-    bytecode_epilog(bci, st);
+    if (ClassPrinter::has_mode(_flags, ClassPrinter::PRINT_PROFILE)) {
+      bytecode_epilog(bci, st);
+    }
   }
 };
 
 // We need a global instance to keep track of the states when the bytecodes
 // are executed. Access by multiple threads are controlled by ttyLocker.
@@ -300,10 +303,16 @@
 
     if (is_linked()) {
       ResolvedIndyEntry* indy_entry = constants()->resolved_indy_entry_at(indy_index);
       st->print("  ResolvedIndyEntry: ");
       indy_entry->print_on(st);
+      if (indy_entry->has_appendix()) {
+        oop apx = constants()->resolved_reference_from_indy(indy_index);
+        //FIXME: lock out of order with runtime/interpreter/BytecodeTracerTest.java
+        //int perm_index = HeapShared::get_archived_object_permanent_index(apx);
+        st->print_cr(" - appendix = " INTPTR_FORMAT, p2i(apx));
+      }
     }
   }
 }
 
 // cp_index: must be the cp_index of a JVM_CONSTANT_{Dynamic, DynamicInError, InvokeDynamic}
